#include "textures.inc"

#declare chest = union
{
        intersection
        {
                blob
                {
                        cylinder
                        {
                                <0, 0, 0 ><0, 1, 0 >,1,10
                                translate< 0.5, 0, 0 >
                        }
                        cylinder
                        {
                                <0, 0, 0 ><0, 1, 0 >,1,10
                                translate< -0.5, 0, 0 >
                        }
                        cylinder
                        {
                                <0, 0, 0 ><0, -1, 0 >,1,10
                                translate< 0.25, 0, 0 >
                        }
                        cylinder
                        {
                                <0, 0, 0 ><0, -1, 0 >,1,10
                                translate< -0.25, 0, 0 >
                        }
                }
                box
                {
                        <-1, -1, -1 >< 1, 1, 1 >
                        scale< 1.5, 1.1, 1.5 >
                }
        }
        union
        {
                cylinder
                {
                        < -1, 0, 0 > < 1, 0, 0 >,1
                        scale< 1, 0.5, 0.5 >
                        translate< 0, 1, 0 >
                }
        }
}

#declare shbase = union
{
        cylinder
        {
                <-1, 0, 0 ><1, 0, 0 >,1
        }
        sphere
        {
                < 0, 0, 0 >,1
                translate< 1, 0, 0 >
        }
        sphere
        {
                < 0, 0, 0 >,1
                translate< -1, 0, 0 >
        }
}

#declare shoulder = union
{
        difference
        {
                difference
                {
                        object
                        {
                                shbase
                        }
                        cylinder
                        {
                                < 0, 0, -2 >< 0, 0, 2 >,1
                                translate< 0, -.75, 0 >
                        }
                }
                union
                {
                        object
                        {
                                shbase
                                scale< 0.99, 0.99, 0.99 >
                        }
                        cylinder
                        {
                                < 0, 0, 0 >< 0, 2, 0 >,1
                        }
                        cylinder
                        {
                                < 0, 0, 0 >< 0, -2, 0 >1
                                translate< -1, -0.2, 0 >
                        }
                        cylinder
                        {
                                < 0, 0, 0 >< 0, -2, 0 >1
                                translate< 1, -0.2, 0 >
                        }
                }
       }
}

#declare helmet = union
{
        difference
        {
                blob
                {
                        cylinder
                        {
                                < 0, 0, 0 > <0, 1, 0 >, 1,10
                        }
                        cylinder
                        {
                                < 0, 0, 0 > <0, 1, 0 >, 0.75,1.1
                                translate< 0, 1.5, 0 >
                        }
                }
                box
                {
                        < -1, 0, -1 ><1, 1, 1 >
                        translate< 0, -1.2, 0 >
                }
        }
}

#declare pants = difference
{
        union
        {
                sphere
                {
                        < 0, 0, 0 >, 1
                        translate< 0.5, 0, 0 >
                }
                sphere
                {
                        < 0, 0, 0 >, 1
                }
                sphere
                {
                        < 0, 0, 0 >, 1
                        translate< -0.5, 0, 0 >
                }
        }
        union
        {
                cylinder
                {
                        < 0, 0, 0 >, < 0, -1, 0 >, 1
                        translate< 1, 0, 0 >
                }
                cylinder
                {
                        < 0, 0, 0 >, < 0, -1, 0 >, 1
                        translate< -1, 0, 0 >
                }
        }
}

#declare right_leg = union
{
        sphere
        {
                < 0, 0, 0 >,1
        }
        cylinder
        {
                < 0, 0, 0 >< 0, -1, 0 >,1
                scale< 1, 3, 1 >
        }
        difference
        {
                sphere
                {
                        < 0, 0, 0 >,1 
                }
                union
                {
                        box
                        {
                                < -2, -2, -2 >< 2, 0, 2 >
                                rotate< -20, 0, 0 >
                        }
                        box
                        {
                                < 2, 2, 2 >< -2, 0, -2 >
                                rotate< 20, 0, 0 >
                        }
                }
                scale< 1.1, 1.2, 1.2 >
                translate< 0, -3, 0 >
        }
        union
        {
                cylinder
                {
                        < 0, 0, 0 >< 0, -1, 0 >,1
                        scale< 0.8, 3.5, 0.8 >
                        translate< 0, -3, 0 >
                }
                union
                {
                        cylinder
                        {
                                < 0, 0, 0 >< 0, 0, -1 >,1
                        }
                        sphere
                        {
                                < 0, 0, 0 >,1
                                translate< 0, 0, -1 >
                        }
                        sphere
                        {
                                < 0, 0, 0 >,1
                                translate< 0, 0, 0.25 >
                        }
                        scale< 1, 0.4, 1 >
                        translate< 0, -6.7, 0 >
                }
                translate< 0, 1.25, -2.5 >
                rotate< -50, 0, 0 >
        }
        rotate< 0, 10, 0 >
        rotate< 50, 0, 0 >
        rotate< 0, 20, 0 >
}

#declare left_leg = union
{
        sphere
        {
                < 0, 0, 0 >,1
        }
        cylinder
        {
                < 0, 0, 0 >< 0, -1, 0 >,1
                scale< 1, 3, 1 >
        }
        difference
        {
                sphere
                {
                        < 0, 0, 0 >,1 
                }
                union
                {
                        box
                        {
                                < -2, -2, -2 >< 2, 0, 2 >
                                rotate< -20, 0, 0 >
                        }
                        box
                        {
                                < 2, 2, 2 >< -2, 0, -2 >
                                rotate< 20, 0, 0 >
                        }
                }
                scale< 1.1, 1.2, 1.2 >
                translate< 0, -3, 0 >
        }
        cylinder
        {
                < 0, 0, 0 >< 0, -1, 0 >,1
                scale< 0.8, 3.5, 0.8 >
                translate< 0, -3, 0 >
        }
        union
        {
                cylinder
                {
                        < 0, 0, 0 >< 0, 0, -1 >,1
                }
                sphere
                {
                        < 0, 0, 0 >,1
                        translate< 0, 0, -1 >
                }
                sphere
                {
                        < 0, 0, 0 >,1
                        translate< 0, 0, 0.25 >
                }
                scale< 1, 0.4, 1 >
                translate< 0, -6.7, 0 >
        }
        rotate< -20, 0, 0 >
}

#declare left_arm = union
{
        sphere
        {
                < 0, 0, 0 >,1
        }
        cylinder
        {
                < 0, 0, 0 >< 0, -1, 0 >,1
                scale< 1, 3, 1 >
        }
        difference
        {
                sphere
                {
                        < 0, 0, 0 >,1 
                }
                union
                {
                        box
                        {
                                < -2, -2, -2 >< 2, 0, 2 >
                                rotate< 20, 0, 0 >
                        }
                        box
                        {
                                < 2, 2, 2 >< -2, 0, -2 >
                                rotate< -20, 0, 0 >
                        }
                }
                scale< 1.1, 1.2, 1.2 >
                translate< 0, -3, 0 >
        }
        union
        {
                cylinder
                {
                        < 0, 0, 0 >< 0, -1, 0 >,1
                        scale< 0.8, 3.5, 0.8 >
                        translate< 0, -3, 0 >
                }
                union
                {
                        cylinder
                        {
                                < 0, 0, 0 >< 0, -1, 0 >,1
                        }
                        sphere
                        {
                                < 0, 0, 0 >,1
                                translate< 0, -1, 0 >
                        }
                        scale< 0.4, 1, 1 >
                        translate< 0, -6.7, 0 >
                }
                translate< 0, 2.5, -3 >
                rotate< -80, 0, 0 >
        }
        rotate< 0, -40, 0 >
        rotate< -50, 0, 0 >
        rotate< 0, 60, 0 >
}

#declare right_arm = union
{
        sphere
        {
                < 0, 0, 0 >,1
        }
        cylinder
        {
                < 0, 0, 0 >< 0, -1, 0 >,1
                scale< 1, 3, 1 >
        }
        difference
        {
                sphere
                {
                        < 0, 0, 0 >,1 
                }
                union
                {
                        box
                        {
                                < -2, -2, -2 >< 2, 0, 2 >
                                rotate< 20, 0, 0 >
                        }
                        box
                        {
                                < 2, 2, 2 >< -2, 0, -2 >
                                rotate< -20, 0, 0 >
                        }
                }
                scale< 1.1, 1.2, 1.2 >
                translate< 0, -3, 0 >
        }
        cylinder
        {
                < 0, 0, 0 >< 0, -1, 0 >,1
                scale< 0.8, 3.5, 0.8 >
                translate< 0, -3, 0 >
        }
        union
        {
                cylinder
                {
                        < 0, 0, 0 >< 0, -1, 0 >,1
                }
                sphere
                {
                        < 0, 0, 0 >,1
                        translate< 0, -1, 0 >
                }
                scale< 0.4, 1, 1 >
                translate< 0, -6.7, 0 >
        }
        rotate< 0, 30, 0 >
        rotate< 130, 0, 0 >
        rotate< 0, 20, 0 >
}

#declare knight = union
{
        object
        {
                chest
        }
        object
        {
                shoulder
                scale< 1, 0.75, 0.95 >
                translate< 0, 0.75, 0 >
        }
        object
        {
                helmet
                scale< 0.75, 0.75, 0.75 >
                translate< 0, 1.5, 0 >
        }
        object
        {
                pants
                translate< 0, -1.7, 0 >
                scale< 0.8, 0.8, 0.8 >
        }
        object
        {
                right_leg
                translate< -1, -3, 0 >
                scale< 0.55, 0.55, 0.55 >
        }
        object
        {
                left_leg
                translate< 1, -3, 0 >
                scale< 0.55, 0.55, 0.55 >
        }
        object
        {               
                left_arm
                rotate< 0, 120, 0 >
                translate< 5.5, 1.5, 0 >
                scale< 0.3, 0.35, 0.3 >
        }
        object
        {               
                right_arm
                translate< -5.5, 1.5, 0 >
                scale< 0.3, 0.35, 0.3 >
        }
        rotate< 10, 0, 0 >
        //rotate< 0, 25, 0 >
        rotate< 0, 140, 0 >
        texture{ steel }
}